diff --git a/contrib/start-scripts/freebsd b/contrib/start-scripts/freebsd
index 10ea48249863f91727789fc6c49d1c98c4ac9216..7e9b103ec09baf2c63ca6f642d1875d899151ccb 100644
--- a/contrib/start-scripts/freebsd
+++ b/contrib/start-scripts/freebsd
@@ -6,7 +6,7 @@
 # Created through merger of the Linux start script by Ryan Kirkpatrick
 # and the script in the FreeBSD ports collection.
 
-# $PostgreSQL: pgsql/contrib/start-scripts/freebsd,v 1.5 2009/08/27 16:59:38 tgl Exp $
+# $PostgreSQL: pgsql/contrib/start-scripts/freebsd,v 1.6 2010/02/23 22:15:35 momjian Exp $
 
 ## EDIT FROM HERE
 
@@ -36,7 +36,14 @@ DAEMON="$prefix/bin/postmaster"
 PGCTL="$prefix/bin/pg_ctl"
 
 # Only start if we can find the postmaster.
-test -x "$DAEMON" || exit 0
+test -x $DAEMON ||
+{
+	echo "$DAEMON not found"
+	if [ "$1" = "stop" ]
+	then exit 0
+	else exit 5
+	fi
+}
 
 case $1 in
     start)
diff --git a/contrib/start-scripts/linux b/contrib/start-scripts/linux
index e1ea1e3da4bbf39deda6759817e95b9c7764a694..dd73e42d173340a4b4a91588ce74fc69a4b29709 100644
--- a/contrib/start-scripts/linux
+++ b/contrib/start-scripts/linux
@@ -24,7 +24,7 @@
 
 # Original author:  Ryan Kirkpatrick <pgsql@rkirkpat.net>
 
-# $PostgreSQL: pgsql/contrib/start-scripts/linux,v 1.10 2010/01/11 18:39:32 tgl Exp $
+# $PostgreSQL: pgsql/contrib/start-scripts/linux,v 1.11 2010/02/23 22:15:35 momjian Exp $
 
 ## EDIT FROM HERE
 
@@ -64,7 +64,15 @@ PGCTL="$prefix/bin/pg_ctl"
 set -e
 
 # Only start if we can find the postmaster.
-test -x $DAEMON || exit 0
+test -x $DAEMON ||
+{
+	echo "$DAEMON not found"
+	if [ "$1" = "stop" ]
+	then exit 0
+	else exit 5
+	fi
+}
+
 
 # Parse command line parameters.
 case $1 in